Módulo
Conteúdo
Índice 🔎︎

# Instrução GoSub...Return

Chama uma sub-rotina indicada pelo rótulo a partir de uma sub-rotina ou função. As instruções subsequentes ao rótulos são executadas até o próximo Return. O programa continua a execução, então, com a instrução que segue a instrução GoSub .

## Sintaxe:

    consulte Parâmetros

## Parâmetros:

Sub/Function

statement block

Rótulo

statement block

GoSub Label

Exit Sub/Function

Label:

statement block

Return

End Sub/Function

A instrução GoSub chama uma sub-rotina local indicada por um rótulo de dentro de uma sub-rotina ou função. O nome do rótulo deve terminar com um sinal de dois-pontos (":").

Se o programa encontra uma instrução Return não precedida por GoSub, o LibreOffice Basic retorna uma mensagem de erro. Use Exit Sub ou a Função Exit para garantir que o programa deixe uma Sub-rotina ou uma Função antes de chegar à próxima instrução Return.

O exemplo a seguir demonstra o uso de GoSub e Return. Executando duas vezes a seção de um programa, o programa calcula a raiz quadrada dos dois números inseridos pelo usuário.

## Exemplo:

    Sub ExampleGoSub

    Dim iInputa As Single

    Dim iInputb As Single

    Dim iInputc As Single

        iInputa = Int(InputBox("Digite o primeiro número: ","NumberInput"))

        iInputb = Int(InputBox("Digite o segundo número: ","NumberInput"))

        iInputc=iInputa

        GoSub SquareRoot

        Print "A raiz quadrada de ";iInputa;" é";iInputc

        iInputc=iInputb

        GoSub SquareRoot

        Print "A raiz quadrada de ";iInputb;" é";iInputc

        Exit Sub

    SquareRoot:

        iInputc=sqr(iInputc)

        Return

    End Sub